// Copyright (c) 2021
// verso 2.0 desenvolvido Doutor Pedro Quaresma

#include <iostream>
#include <stdio.h>

#include "cifrasSubstituicao.hpp" // Classe com as Cifras de Deslocamento

using namespace std;

int main(int argc, char *argv[]){

  //fl -> o ficheiro de entrada(leitura) 
  //fe -> o ficheiro de saida(escrita)
  
  FILE *fl,*fe;
  
  //verificar o nmero de argumento
  if(argc!=4){
    cout << "\nUtilizaao: desencriptarDS nome_ficheiro_entrada chave nome_ficheiro_saida\n\n";
    return(1);
  }
  
  //Declarao das variveis
  char *menscifrada, *mensdecifrada;
  int ch;
  int caracter;
  int resultado;
  int chave;
  
  //cpia do ficheiro de entrada
  menscifrada = argv[1];
  
 
  //funcao atoi recebe uma string e devolve o inteiro que nela esta representado
  chave=atoi(argv[2]);
  
  //fazer copia
  mensdecifrada = argv[3];
  
  //abrir o ficheiro para a leitura
  fl = fopen(menscifrada,"r");
  
  //verificar se o ficheiro foi aberto ou nao
  //caso contrario o programa termina
  if(fl==NULL){
    cout << "Impossvel abrir o ficheiro " << menscifrada << endl;
    return(2);
  }
  
  //Abrir o ficheiro para escrever a mensagem decifrada
  if((fe = fopen(mensdecifrada,"w"))==NULL){
    cout << "Impossivel criar o ficheiro " << mensdecifrada << endl;
    return(3);
  }

  CifrasSubstituicao cifraDS;
  
  //Aplicar a Cifra de Deslocamento Simples
  while((ch=fgetc(fl))!=EOF){
    resultado = cifraDS.desencriptarDS(ch,chave);
    fprintf(fe,"%c",resultado);
  }
  
  
  //Fechar os ficheiros
  fclose(fl);
  fclose(fe);
  
  return(0);
  
}
